=== Tests/12.Solvers/CMakeLists.txt ===
# 
siesta_subtest(si_default)
siesta_subtest(si_procy)
siesta_subtest(si_mrrr)
siesta_subtest(si_omm1)
siesta_subtest(si_omm2)
siesta_subtest(si_on)

if(SIESTA_WITH_ELSI)
 siesta_subtest(si-qdot-elsi-elpa LABELS long)
 siesta_subtest(si-qdot-elsi-elpa-1stage LABELS long)
 if(ELSI_ELPA_HAS_GPU_SUPPORT)
   siesta_subtest(si-qdot-elsi-elpa-gpu LABELS long)
   siesta_subtest(si-qdot-elsi-elpa-1stage-gpu LABELS long)
 endif()
 siesta_subtest(sih-elsi LABELS simple)
 if(ELSI_HAS_PEXSI)
   siesta_subtest(si-qdot-elsi-pexsi LABELS long MPI_MINPROCS 2)
 endif()
endif()

if(SIESTA_WITH_PEXSI)
  siesta_subtest(si-qdot-pexsi-native FILES_SETUP coords.Si987H372.fdf LABELS long MPI_MINPROCS 2)
endif()

if(SIESTA_WITH_ELPA)
  siesta_subtest(si-qdot-elpa-native FILES_SETUP coords.Si987H372.fdf LABELS long)
  siesta_subtest(si-qdot-elpa-native-1stage FILES_SETUP coords.Si987H372.fdf si-qdot-elpa-native.fdf LABELS long)
  if(SIESTA_ELPA_HAS_GPU_SUPPORT)
    siesta_subtest(si-qdot-elpa-native-gpu FILES_SETUP si-qdot-elpa-native.fdf coords.Si987H372.fdf LABELS long)
    siesta_subtest(si-qdot-elpa-native-1stage-gpu FILES_SETUP coords.Si987H372.fdf si-qdot-elpa-native.fdf LABELS long)
  endif()
endif()
