=== Util/QMMM-driver/Tests/MM-Gly/CMakeLists.txt ===
siestaqmmm_subtest(gly MMONLY LABELS qmmm FILES_SETUP amber.parm)
